"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggerNestAdapter = void 0;
const common_1 = require("@nestjs/common");
class LoggerNestAdapter extends common_1.ConsoleLogger {
    constructor(logger) {
        super();
        this.logger = logger;
    }
    log(message, context, ...optionalParams) {
        return this.logger.info(message, context, this.getLogData(optionalParams));
    }
    error(message, context, ...optionalParams) {
        return this.logger.error(message, context, this.getLogData(optionalParams));
    }
    warn(message, context, ...optionalParams) {
        return this.logger.warn(message, context, this.getLogData(optionalParams));
    }
    debug(message, context, ...optionalParams) {
        return this.logger.debug(message, context, this.getLogData(optionalParams));
    }
    verbose(message, context, ...optionalParams) {
        return this.logger.info(message, context, this.getLogData(optionalParams));
    }
    getLogData(...optionalParams) {
        return {
            sourceClass: optionalParams[0] ? optionalParams[0] : undefined,
        };
    }
}
exports.LoggerNestAdapter = LoggerNestAdapter;
