"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggerService = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const logger_types_1 = require("./logger.types");
let LoggerService = class LoggerService {
    constructor(logger, parentClass) {
        this.logger = logger;
        this.sourceClass = parentClass?.constructor.name;
    }
    log(level, message, context, data) {
        return this.logger.log(level, message, context, this.getLogData(data));
    }
    debug(message, context, data) {
        return this.logger.debug(message, context, this.getLogData(data));
    }
    info(message, context, data) {
        return this.logger.info(message, context, this.getLogData(data));
    }
    warn(message, context, data) {
        return this.logger.warn(message, context, this.getLogData(data));
    }
    error(message, context, data) {
        return this.logger.error(message, context, this.getLogData(data));
    }
    fatal(message, context, data) {
        return this.logger.fatal(message, context, this.getLogData(data));
    }
    emergency(message, context, data) {
        return this.logger.emergency(message, context, this.getLogData(data));
    }
    getLogData(data) {
        return data;
    }
};
exports.LoggerService = LoggerService;
exports.LoggerService = LoggerService = __decorate([
    (0, common_1.Injectable)({ scope: common_1.Scope.TRANSIENT }),
    __param(0, (0, common_1.Inject)(logger_types_1.LoggerBaseKey)),
    __param(1, (0, common_1.Inject)(core_1.INQUIRER)),
    __metadata("design:paramtypes", [Object, Object])
], LoggerService);
