"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WinstonLoggerTransportsKey = void 0;
const common_1 = require("@nestjs/common");
const winston = __importStar(require("winston"));
const logger_types_1 = require("#/logger/logger.types");
exports.WinstonLoggerTransportsKey = Symbol();
let WinstonLogger = class WinstonLogger {
    constructor(transports) {
        // Create winston logger
        this.logger = winston.createLogger(this.getLoggerFormatOptions(transports));
    }
    getLoggerFormatOptions(transports) {
        // Setting log levels for winston
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        const levels = {};
        let cont = 0;
        Object.values(logger_types_1.LOG_LEVEL).forEach((level) => {
            levels[level] = cont;
            cont++;
        });
        return {
            level: logger_types_1.LOG_LEVEL.Debug,
            levels,
            format: winston.format.combine(
            // Add timestamp and format the date
            winston.format.timestamp({
                format: 'DD/MM/YYYY, HH:mm:ss',
            }), 
            // Errors will be logged with stack trace
            winston.format.errors({ stack: true }), 
            // Add custom Log fields to the log
            winston.format((info) => {
                // Info contains an Error property
                // console.log('--- WINSTONM LOOGER', info);
                if (info.data && info.data instanceof Error) {
                    info.stack = info.data.stack;
                    info.data = undefined;
                }
                let splat = info[Symbol.for('splat')] ?? undefined;
                if (splat !== undefined) {
                    if (Array.isArray(splat)) {
                        splat = splat[0];
                    }
                    info.context = splat?.context ?? undefined;
                    info.data = splat?.data ?? undefined;
                }
                // console.log(info);
                return info;
            })(), winston.format.json()),
            transports: transports,
            exceptionHandlers: transports,
            rejectionHandlers: transports,
        };
    }
    log(level, message, context, data) {
        const m = message instanceof Error ? message.message : message;
        const payload = {
            context,
            data,
        };
        this.logger.log(level, m, payload);
    }
    debug(message, context, data) {
        this.log(logger_types_1.LOG_LEVEL.Debug, message, context, data);
    }
    info(message, context, data) {
        this.log(logger_types_1.LOG_LEVEL.Info, message, context, data);
    }
    warn(message, context, data) {
        this.log(logger_types_1.LOG_LEVEL.Warn, message, context, data);
    }
    error(message, context, data) {
        this.log(logger_types_1.LOG_LEVEL.Error, message, context, data);
    }
    fatal(message, context, data) {
        this.log(logger_types_1.LOG_LEVEL.Fatal, message, context, data);
    }
    emergency(message, context, data) {
        this.log(logger_types_1.LOG_LEVEL.Emergency, message, context, data);
    }
};
WinstonLogger = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(exports.WinstonLoggerTransportsKey)),
    __metadata("design:paramtypes", [Array])
], WinstonLogger);
exports.default = WinstonLogger;
