import { ConsoleLogger } from '@nestjs/common';
import { LoggerService } from '@nestjs/common/services/logger.service';

import { Logger } from './logger.types';

export class LoggerNestAdapter extends ConsoleLogger implements LoggerService {
	public constructor(private logger: Logger) {
		super();
	}

	public log(message: string, context: string, ...optionalParams: unknown[]) {
		return this.logger.info(message, context, this.getLogData(optionalParams));
	}

	public error(message: string, context: string, ...optionalParams: unknown[]) {
		return this.logger.error(message, context, this.getLogData(optionalParams));
	}

	public warn(message: string, context: string, ...optionalParams: unknown[]) {
		return this.logger.warn(message, context, this.getLogData(optionalParams));
	}

	public debug(message: string, context: string, ...optionalParams: unknown[]) {
		return this.logger.debug(message, context, this.getLogData(optionalParams));
	}

	public verbose(message: string, context: string, ...optionalParams: unknown[]) {
		return this.logger.info(message, context, this.getLogData(optionalParams));
	}

	private getLogData(...optionalParams: unknown[]) {
		return {
			sourceClass: optionalParams[0] ? optionalParams[0] : undefined,
		};
	}
}
