export type AttachementField = {
	title: string;
	value: string;
	short: boolean;
};

export type Attachment = {
	color: '#36a64f';
	author_icon?: string;
	title?: string;
	text?: string;
	fields: AttachementField[];
	footer?: string;
	footer_icon?: string;
	ts?: number;
};

export type ErrorMessageWithAttachment = {
	attachments: Attachment[];
	blocks: [
		{
			type: string;
			text: {
				type: 'plain_text';
				text: string;
				emoji: true;
			};
		},
		{
			type: 'context';
			elements: [
				{
					type: 'mrkdwn';
					text: string;
				},
			];
		},
		{
			type: 'divider';
		},
		{
			type: 'section';
			fields: [
				{
					type: 'mrkdwn';
					text: '*Error Context:*';
				},
				{
					type: 'mrkdwn';
					text: string;
				},
			];
		},
		{
			type: 'divider';
		},
		{
			type: 'section';
			fields: [
				{
					type: 'mrkdwn';
					text: '*Error Response:*';
				},
				{
					type: 'mrkdwn';
					text: string;
				},
			];
		},
		{
			type: 'divider';
		},
		{
			type: 'section';
			fields: [
				{
					type: 'mrkdwn';
					text: '*Error Message:*';
				},
				{
					type: 'mrkdwn';
					text: string;
				},
			];
		},
	];
};
